<template>
  <div class="doc-markdown doc-markdown--toc">
    <div>
      <div class="doc-markdown__toc">
        <h2>Table of content</h2>
        <nav class="doc-markdown__toc__content">
          <ol class="-unstyled">
            <li v-for="(item, id) in links" :key="id" :style="`padding-left:${((item.deepness - 2) || 0) * 10}px`">
              <a :href="`#${id}`">{{ item.text }}</a>
            </li>
          </ol>
        </nav>
      </div>
    </div>
    <div ref="content" class="doc-markdown__content">
      <slot />
    </div>
  </div>
</template>

<script>
import { parameterize } from '../../../src/lib/String.js'

export default {
  name: 'DocContentWithToc',
  props: {
    tocDeepness: { required: false, type: Number, default: 3 },
  },
  data () {
    return {
      links: {},
    }
  },
  mounted () {
    const links = {}
    const selectors = []
    for (let i = 1; i < this.tocDeepness; i++) {
      selectors.push(`h${i + 1}`)
    }

    this.$refs.content.querySelectorAll(selectors.join(',')).forEach((e) => {
      const id = e.id || parameterize(e.innerText)
      links[id] = {
        text: e.innerText,
        deepness: parseInt(e.tagName.split('H')[1], 10),
      }
      e.id = id
    })
    this.links = links
  },
}
</script>
